//  This file is part of ff3d - http://www.freefem.org/ff3d
//  Copyright (C) 2001, 2002, 2003 Stphane Del Pino

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

//  $Id: OStreamExpression.cpp,v 1.3 2006/12/30 01:32:08 delpinux Exp $

#include <OStreamExpression.hpp>

#include <OFStreamExpression.hpp>
#include <Variable.hpp>

std::ostream&
OStreamExpression::
put(std::ostream & os) const
{
  return os;
}

void
OStreamExpression::
execute()
{
  ;
}

void
OStreamExpression::
operator<<(Expression& E)
{
  if (__ostream != 0) {
    (*__ostream) << E;
  } else {
    assert(__ofstreamVariable->expression()->ofstream() != 0);
    (*__ofstreamVariable->expression()->ofstream()) << E << std::flush;
  }
}

OStreamExpression::
OStreamExpression(OStream* os)
  : Expression(Expression::ostreamexpression),
    __ostream(os),
    __ofstreamVariable(0)
{
  ;
}

OStreamExpression::
OStreamExpression(OFStreamVariable* ov)
  : Expression(Expression::ostreamexpression),
    __ostream(0),
    __ofstreamVariable(ov)
{
  ;
}

OStreamExpression::
OStreamExpression(const OStreamExpression& os)
  : Expression(*this),
    __ostream(os.__ostream),
    __ofstreamVariable(os.__ofstreamVariable)
{
  ;
}

OStreamExpression::
~OStreamExpression()
{
  ;
}

