//  This file is part of ff3d - http://www.freefem.org/ff3d
//  Copyright (C) 2001, 2002, 2003 Stphane Del Pino

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

//  $Id: FieldFunctionWriterVTK.hpp,v 1.1 2006/11/16 17:46:03 delpinux Exp $

#ifndef FIELD_FUNCTION_WRITER_VTK_HPP
#define FIELD_FUNCTION_WRITER_VTK_HPP

#include <FieldFunctionWriterBase.hpp>

/**
 * @file   FieldFunctionWriterVtk.hpp
 * @author Stephane Del Pino
 * @date   Mon Aug 21 19:35:53 2006
 * 
 * @brief Writer for field functions using the vtk format
 * 
 */
class FieldFunctionWriterVTK
  : public FieldFunctionWriterBase
{
private:
  template <typename CellType>
  struct Traits;

  FieldFunctionWriterVTK(const FieldFunctionWriterVTK& writer);

  template <typename MeshType>
  void __proceed() const;

public:
  void proceed() const;

  FieldFunctionWriterVTK(ConstReferenceCounting<ScalarFunctionBase> f1,
			 ConstReferenceCounting<ScalarFunctionBase> f2,
			 ConstReferenceCounting<ScalarFunctionBase> f3,
			 ConstReferenceCounting<Mesh> mesh,
			 const std::string& fileName,
			 const std::string& CR);

  virtual ~FieldFunctionWriterVTK();
};

#endif // SCALAR_FUNCTION_WRITER_VTK_HPP
