//  This file is part of ff3d - http://www.freefem.org/ff3d
//  Copyright (C) 2006 Stphane Del Pino

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

//  $Id: ScalarFunctionReaderRaw.hpp,v 1.1 2006/09/20 16:46:33 delpinux Exp $

#ifndef SCALAR_FUNCTION_READER_RAW_HPP
#define SCALAR_FUNCTION_READER_RAW_HPP

#include <ScalarFunctionReaderBase.hpp>

/**
 * @file   ScalarFunctionReaderRaw.hpp
 * @author Stephane Del Pino
 * @date   Thu Jul 20 11:32:14 2006
 * 
 * @brief  Raw file format reader
 * 
 */
class ScalarFunctionReaderRaw
  : public ScalarFunctionReaderBase
{
public:
  /** 
   * Read the function in a file
   * 
   * @return the read function
   */
  ConstReferenceCounting<ScalarFunctionBase>
  getFunction() const;

  /** 
   * Constructor
   * 
   * @param filename file name
   * @param mesh given mesh
   */
  ScalarFunctionReaderRaw(const std::string& filename,
			  ConstReferenceCounting<Mesh> mesh);

  /** 
   * Copy cnstructor
   * 
   * @param f given function
   */
  ScalarFunctionReaderRaw(const ScalarFunctionReaderRaw& f);

  /** 
   * Destructor
   * 
   */
  ~ScalarFunctionReaderRaw();
};

#endif // SCALAR_FUNCTION_READER_MEDIT_HPP
