//  This file is part of ff3d - http://www.freefem.org/ff3d
//  Copyright (C) 2001, 2002, 2003 Stphane Del Pino

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

//  $Id: ScalarFunctionWriterMedit.hpp,v 1.2 2006/11/16 17:46:03 delpinux Exp $

#ifndef SCALAR_FUNCTION_WRITER_MEDIT_HPP
#define SCALAR_FUNCTION_WRITER_MEDIT_HPP

#include <ScalarFunctionWriterBase.hpp>

/**
 * @file   ScalarFunctionWriterMedit.hpp
 * @author Stephane Del Pino
 * @date   Mon Aug 21 19:35:53 2006
 * 
 * @brief Writer for scalar functions using the medit format
 * 
 */
class ScalarFunctionWriterMedit
  : public ScalarFunctionWriterBase
{
private:
  ScalarFunctionWriterMedit(const ScalarFunctionWriterMedit& writer);

public:
  void proceed() const;

  ScalarFunctionWriterMedit(ConstReferenceCounting<ScalarFunctionBase> function,
			    ConstReferenceCounting<Mesh> mesh,
			    const std::string& fileName,
			    const std::string& CR);

  virtual ~ScalarFunctionWriterMedit();
};

#endif // SCALAR_FUNCTION_WRITER_MEDIT_HPP
