//  This file is part of ff3d - http://www.freefem.org/ff3d
//  Copyright (C) 2001, 2002, 2003 Stphane Del Pino

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

//  $Id: ScalarFunctionWriterVTK.hpp,v 1.1 2006/09/10 23:47:57 delpinux Exp $

#ifndef SCALAR_FUNCTION_WRITER_VTK_HPP
#define SCALAR_FUNCTION_WRITER_VTK_HPP

#include <ScalarFunctionWriterBase.hpp>

/**
 * @file   ScalarFunctionWriterVTK.hpp
 * @author Stephane Del Pino
 * @date   Mon Aug 21 19:35:53 2006
 * 
 * @brief Writer for scalar functions using the VTK format
 */
class ScalarFunctionWriterVTK
  : public ScalarFunctionWriterBase
{
private:
  template <typename CellType>
  struct Traits;

  ScalarFunctionWriterVTK(const ScalarFunctionWriterVTK& writer);

  template <typename MeshType>
  void __proceed() const;

public:
  void proceed() const;

  ScalarFunctionWriterVTK(ConstReferenceCounting<ScalarFunctionBase> function,
			  ConstReferenceCounting<Mesh> mesh,
			  const std::string& fileName,
			  const std::string& CR);

  virtual ~ScalarFunctionWriterVTK();
};

#endif // SCALAR_FUNCTION_WRITER_VTK_HPP
